
#include	<stdio.h>
#include	<stdlib.h>
#include	<math.h>

void make_eigen(double *keepin, double *out, double *vals, int size);

#define	MAXSIZE	40

double	This[MAXSIZE],
	Avg[MAXSIZE],
	Std[MAXSIZE],
	Covar[MAXSIZE * MAXSIZE],
	Eigen[MAXSIZE * MAXSIZE],
	Eigval[MAXSIZE];

int main(int argc, char **argv)
{
	struct datum	*p;
	int	numi, j, k, ncnt;
	int	Size;

	if (argc != 2) {
		fprintf(stderr, "Usage: covariance #Size\n");
		exit(1);
	}
	Size = atoi(argv[1]);
	for (ncnt = 0; ; ++ncnt) {
		numi = scanf("%lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf "
			+ 4*(40 - Size),
			This + 0, This + 1, This + 2, This + 3, This + 4,
			This + 5, This + 6, This + 7, This + 8, This + 9,
			This + 10, This + 11, This + 12, This + 13, This + 14,
			This + 15, This + 16, This + 17, This + 18, This + 19,
			This + 20, This + 21, This + 22, This + 23, This + 24,
			This + 25, This + 26, This + 27, This + 28, This + 29,
			This + 30, This + 31, This + 32, This + 33, This + 34,
			This + 35, This + 36, This + 37, This + 38, This + 39);
		if (numi != Size)
			break;
		for (j = 0; j < Size; j++) {
			Avg[j] += This[j];
			Std[j] += This[j] * This[j];
			for (k = 0; k < Size; k++) {
				Covar[j*Size + k] +=
					This[j] * This[k];
			}
		}
	}

	for (j = 0; j < Size; j++) {
		Avg[j] /= ncnt;
		Std[j] /= ncnt;
		Std[j] -= Avg[j] * Avg[j];
		Std[j] = sqrt(Std[j]);
	}
	for (j = 0; j < Size; j++)
	for (k = 0; k < Size; k++) {
		Covar[j*Size + k] -= Avg[j] * Avg[k] * ncnt;
		Covar[j*Size + k] /= Std[j] * Std[k] * ncnt;
	}
	printf("Covariance:\n");
	for (j = 0; j < Size; j++) {
		for (k = 0; k < Size; k++) {
			printf("%5.4f ", Covar[j*Size + k]);
		}
		printf("\n");
	}
	printf("Ncnt = %d\n", ncnt);
	make_eigen(Covar, Eigen, Eigval, Size);
	printf("Eigenmatrix:\n");
	for (j = 0; j < Size; j++) {
		for (k = 0; k < Size; k++) {
			printf("%7.4f ", Eigen[j*Size + k]);
		}
		printf("  Eigv = %5.3f\n", Eigval[j]);
	}
	exit(0);
}
