
#include	<stdlib.h>
#include	<stdio.h>
#include	<string.h>

#define	MAXEL	100000

struct codnod {
	unsigned long	valu;
	double	freq;
	int	left, righ;
} Codnod[MAXEL + MAXEL + 10];

int cncomp(const void *p1, const void *p2)
{
	double f1, f2;
	f1 = ((struct codnod *)p1)->freq;
	f2 = ((struct codnod *)p2)->freq;
	return f1 < f2 ? -1 : f1 == f2 ? 0 : 1;
}

void showcode(int n, int bitcnt)
{
	struct codnod *p = Codnod + n;

	if (p->righ == 0) {
		/* Leaf */
		printf(" %lu %d (%f)\n", p->valu, bitcnt, p->freq);
		return;
	}
	showcode (p->left, bitcnt + 1);
	showcode (p->righ, bitcnt + 1);
}

char	Buff[1000];

int main(int argc, char **argv)
{
	int	j;
	int	hexmode = 0;
	int	Numel, Smallel;
	struct codnod Tempcdn;
	unsigned long ivalu;
	double	ffreq;

	if (argv[1] && ! strcmp(argv[1], "-x"))
		hexmode = 1;
	Numel = 0;
	/* Insert a low-frequency dummy (for markers?) */
	Codnod[Numel].valu = 0xffffff;
	Codnod[Numel].freq = .000000001;
	++Numel;
	while (gets(Buff)) {
		sscanf(Buff, hexmode ?
				" %04lx  %lf" :
				" %lu %lf",
				&ivalu, &ffreq);
		Codnod[Numel].valu = ivalu;
		Codnod[Numel].freq = ffreq;
		++Numel;
	}
	qsort(Codnod, Numel, sizeof *Codnod, cncomp);
	for (Smallel = 0; Smallel < Numel - 1; Smallel += 2, Numel += 1) {
		/* From elements [Smallel] and [Smallel+1], form [Numel] */
		Tempcdn.freq = Codnod[Smallel].freq + Codnod[Smallel + 1].freq;
		Tempcdn.left = Smallel;
		Tempcdn.righ = Smallel + 1;
		for (j = Numel; j > Smallel + 2; j--) {
			if (Tempcdn.freq >= Codnod[j - 1].freq)
				break;
			Codnod[j] = Codnod[j - 1];
		}
		Codnod[j] = Tempcdn;
	}
	showcode(Smallel, 0);
	exit(0);
}
