
#include	<stdio.h>
#include	<stdlib.h>
#include	<math.h>
#include	"kahan.h"

#define EXIT_GOOD       0
#define EXIT_USAGE      64      /* command line usage error */

double	bincoef(int n, int m)
{
	double	ans;
	for (ans = 1; m; m--, n--)
		ans *= n, ans /= m;
	return ans;
}

struct KahanAdder Cumu, Cmom;

/* Usage a.exe N p -- show probability of (0,1,...,N) events each with prob p */
int main(int argc, char **argv)
{
	int	n, j;
	double	p, x, tcumu, tcmom = 0;

	if (argc != 3) {
		printf("Usage: num_occ #N #p\n\t\
-- report how many of N events happen, each with probability p\n");
		exit(EXIT_USAGE);
	}
	n = atoi(argv[1]);
	p = atof(argv[2]);
	for (j = 0; j <= n; j++) {
		x = bincoef(n, j);
		x *= pow(p, (double)j);
		x *= pow(1 - p, (double)n - j);
		tcumu = kahan_add(&Cumu, x);
		tcmom = kahan_add(&Cmom, x * j);
		printf("%d events out of %d --> %g (cumulative %g)\n",
				j, n, x, tcumu);
	}
	printf("Mean number of events = %g\n", tcmom);

	exit(EXIT_GOOD);
}
