
#include	<stdio.h>
#include	<stdlib.h>
#include	<math.h>
#include	"../jdas_common/j_random.h"

/*
 * Average size of riangle chosen from points in N-cube 
 */
#ifndef	NDIM
#define	NDIM	2
#endif

struct point {
	double x[NDIM];
} Pt[3];

double distance(struct point *p1, struct point *p2)
{
	double	a, summ = 0;
	int	i;

	for (i = 0; i < NDIM; i++) {
		a = p1->x[i] - p2->x[i];
		summ += a * a;
	}
	return sqrt(summ);
}

double tri_area(void)
{
	double	a, b, c, s;
	a = distance(Pt + 0, Pt + 1);
	b = distance(Pt + 0, Pt + 2);
	c = distance(Pt + 1, Pt + 2);
	s = (a + b + c) / 2;
	s *= (s-a) * (s-b) * (s-c);
	return s > 0 ? sqrt(s) : 0;
}

void setpt(struct point *p)
{
	int	i;

	for (i = 0; i < NDIM; i++)
		p->x[i] = rand_unif(0.0, 1.0);
}

int main(int argc, char **argv)
{
	long double totarea = 0;
	int	iter, i;
#define	NUMITER	1000000

	setlinebuf(stdout);
	for (iter = 0; iter < NUMITER; iter++) {
		for (i = 0; i < 3; i++)
			setpt(Pt + i);
		totarea += tri_area();
	}
	printf("%f\n", (double)(totarea / iter));
	exit(0);
}
